/*
One of those Weeks episode 35:BSoDs in Space
Copyright (c) 2008-2009 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep35
{
	// Adobe Imports
	import flash.display.SimpleButton;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;

	public class SpaceShip
	extends MovieClip
	{
// ***** CONSTANTS ***********************************************************

		protected static const ROTATION:Number = 200.0;
		protected static const ACCELERATION:Number = 50;
		protected static const MAX_SPEED:Number = 100;

// ***** VARIABLES ***********************************************************

		protected var _xspeed:Number;
		protected var _yspeed:Number;

		// note that all _*_movie, _*_btn and _*_txt variables are in movie

// ***** CONSTRUCTOR *********************************************************

		public function SpaceShip()
		{
			x = 320;
			y = 240;
			_xspeed = 0;
			_yspeed = 0;
		}

// ***** Functions - Event handlers ******************************************


// ***** Functions - General control *****************************************

		public function turnLeft(delta:Number)
		{
			rotation -= (delta * ROTATION);
		}
		
		public function turnRight(delta:Number)
		{
			rotation += (delta * ROTATION);
		}
		
		public function accelerate(delta:Number)
		{
			var rad:Number = rotation * Math.PI/180;

			_xspeed = Math.max(-MAX_SPEED, 
					Math.min(MAX_SPEED, 
					_xspeed + delta * ACCELERATION * Math.sin(rad)));
			_yspeed = Math.max(-MAX_SPEED,
					Math.min(MAX_SPEED, 
					_yspeed + delta * ACCELERATION * -Math.cos(rad)));
			trace ("speed: " + _xspeed + "," + _yspeed);
		}

		public function fullStop()
		{
			_xspeed = 0;
			_yspeed = 0;
		}
		
		public function updatePosition(delta)
		{
			x += _xspeed * delta;
			y += _yspeed * delta;
			if (x < -(width/2))
				x = stage.stageWidth + width/2;
			else if (x > (stage.stageWidth + width /2))
				x = -width/2;

			if (y < -(height/2))
				y = stage.stageHeight + height/2;
			else if (y > (stage.stageHeight + height/2))
				y = -height/2;

		}
	} // end class
} // end package
